<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>net.jami</groupId>
    <artifactId>jams3-parent</artifactId>
    <packaging>pom</packaging>
    <version>${revision}</version>
    <name>Jami Account Management Server</name>
    <modules>
        <module>jams-server</module>
        <module>jams-common</module>
        <module>jams-ca</module>
        <module>ad-connector</module>
        <module>ldap-connector</module>
        <module>datastore</module>
        <module>jami-dht</module>
        <module>authentication-module</module>
        <module>jami-nameserver</module>
        <module>jams-launcher</module>
    </modules>

    <properties>
        <revision>3.8</revision>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <maven.compiler.source>11</maven.compiler.source>
        <maven.compiler.target>11</maven.compiler.target>
        <maven.compiler.version>3.12.1</maven.compiler.version>
        <java.version>11</java.version>
        <bouncy.castle.version>1.77</bouncy.castle.version>
        <lombok.version>1.18.30</lombok.version>
        <log4j.version>1.7.30</log4j.version>
        <jupiter.api.version>5.7.0-M1</jupiter.api.version>
        <junit-vintage.version>5.10.2</junit-vintage.version>
        <mockito.version>5.11.0</mockito.version>
        <mockito-inline.version>5.2.0</mockito-inline.version>
        <byte-buddy.version>1.14.12</byte-buddy.version>
        <tomcat.version>10.1.24</tomcat.version>
        <map.struct.version>1.3.0.Final</map.struct.version>
        <maven.surefire.version>3.2.5</maven.surefire.version>
        <gson.version>2.10.1</gson.version>
        <javassist.version>3.27.0-GA</javassist.version>
        <derby.version>10.14.2.0</derby.version>
        <msgpack.version>0.8.16</msgpack.version>
        <commons.codec.version>1.11</commons.codec.version>
        <xbean.version>4.17</xbean.version>
        <maven.shade.version>3.5.2</maven.shade.version>
        <imperva.ddc.version>7.3.3.0.0.0</imperva.ddc.version>
        <ldaptive.version>2.0.0-RC4</ldaptive.version>
        <maven.clean.version>3.1.0</maven.clean.version>
        <nimbus.jwt.version>8.17</nimbus.jwt.version>
        <asm.version>8.0</asm.version>
        <ez.vcard.version>0.10.6</ez.vcard.version>
        <maven.resources.version>3.3.1</maven.resources.version>
        <embedded.ldap.unit>0.8.1</embedded.ldap.unit>
        <zmq.version>0.5.2</zmq.version>
        <flyway.version>9.21.1</flyway.version>
        <jacoco.version>0.8.11</jacoco.version>
    </properties>

    <dependencies>
        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <version>${lombok.version}</version>
        </dependency>
        <dependency>
            <groupId>org.mapstruct</groupId>
            <artifactId>mapstruct-processor</artifactId>
            <version>${map.struct.version}</version>
        </dependency>
        <dependency>
            <groupId>org.slf4j</groupId>
            <artifactId>slf4j-simple</artifactId>
            <version>${log4j.version}</version>
        </dependency>
        <dependency>
            <groupId>org.slf4j</groupId>
            <artifactId>slf4j-api</artifactId>
            <version>${log4j.version}</version>
        </dependency>
        <dependency>
            <groupId>com.google.code.gson</groupId>
            <artifactId>gson</artifactId>
            <version>${gson.version}</version>
        </dependency>
        <dependency>
            <groupId>org.javassist</groupId>
            <artifactId>javassist</artifactId>
            <version>${javassist.version}</version>
        </dependency>
        <dependency>
            <groupId>org.junit.jupiter</groupId>
            <artifactId>junit-jupiter</artifactId>
            <version>${jupiter.api.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.mockito</groupId>
            <artifactId>mockito-core</artifactId>
            <version>${mockito.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.mockito</groupId>
            <artifactId>mockito-junit-jupiter</artifactId>
            <version>${mockito.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.mockito</groupId>
            <artifactId>mockito-inline</artifactId>
            <version>${mockito-inline.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>net.bytebuddy</groupId>
            <artifactId>byte-buddy</artifactId>
            <version>${byte-buddy.version}</version>
        </dependency>
    </dependencies>

    <build>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>${maven.compiler.version}</version>
                <configuration>
                    <source>${java.version}</source>
                    <target>${java.version}</target>
                    <annotationProcessorPaths>
                        <path>
                            <groupId>org.projectlombok</groupId>
                            <artifactId>lombok</artifactId>
                            <version>${lombok.version}</version>
                        </path>
                    </annotationProcessorPaths>
                </configuration>
            </plugin>
            <plugin>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>${maven.surefire.version}</version>
            </plugin>
            <plugin>
                <artifactId>maven-clean-plugin</artifactId>
                <version>${maven.clean.version}</version>
                <configuration>
                    <filesets>
                        <fileset>
                            <directory>.</directory>
                            <includes>
                                <include>**/*.tmp</include>
                                <include>**/*.log</include>
                                <include>**/versions.json</include>
                            </includes>
                        </fileset>
                        <fileset>
                            <directory>jams/</directory>
                            <includes>
                                <include>**</include>
                            </includes>
                            <followSymlinks>false</followSymlinks>
                        </fileset>
                        <fileset>
                            <directory>coverage/</directory>
                            <includes>
                                <include>**</include>
                            </includes>
                        </fileset>
                    </filesets>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
                <version>${jacoco.version}</version>
                <executions>
                    <execution>
                        <id>jacoco-initialize</id>
                        <goals>
                            <goal>prepare-agent</goal>
                        </goals>
                    </execution>
                    <execution>
                        <id>jacoco-report</id>
                        <phase>test</phase>
                        <goals>
                            <goal>report</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>

        </plugins>
    </build>

</project>
